import type { asIn, asOut } from "../../scopes/type.js";
import type { nominal } from "../../utils/generics.js";
import type { inferDefinition, validateDefinition } from "../definition.js";
import type { PostfixParser, TupleExpression } from "./tuple.js";
export declare const parseMorphTuple: PostfixParser<"=>">;
export type Out<t = {}> = nominal<t, "out">;
export type validateMorphTuple<def extends TupleExpression, $> = readonly [
    _: validateDefinition<def[0], $>,
    _: "=>",
    _: Morph<asOut<inferDefinition<def[0], $>>, unknown>
];
export type Morph<i = any, o = unknown> = (In: i) => o;
export type ParsedMorph<i = any, o = unknown> = (In: i) => Out<o>;
export type inferMorph<inDef, morph, $> = morph extends Morph ? (In: asIn<inferDefinition<inDef, $>>) => Out<ReturnType<morph>> : never;
export declare const writeMalformedMorphExpressionMessage: (value: unknown) => string;
